import unittest
import file_manager as f
import os


class SimpleTest(unittest.TestCase):

    # Test function makeFileAndWriteText
    def test1AFunctionMakeFileAndWriteText(self):
        f.makeFileAndWriteText("test01.txt", "Test")
        # Připojení k souboru - mód čtení ze souboru
        with open("test01.txt", mode="r", encoding="utf-8") as a_file:
            # Čtení ze souboru - po řádcích
            for radek in a_file:
                radek1 = radek
        self.assertTrue((radek1 == "Test"),"Nefunguje 1. funkce")
        os.remove("test01.txt")

    def test1BFunctionMakeFileAndWriteText(self):
        f.makeFileAndWriteText("test02.txt", "Test1\nTest2\nTest3")
        # Připojení k souboru - mód čtení ze souboru
        radky = []
        with open("test02.txt", mode="r", encoding="utf-8") as a_file:
            # Čtení ze souboru - po řádcích
            for radek in a_file:
                radek = radek.replace("\n","")
                radky.append(radek)
        self.assertTrue(radky == ["Test1","Test2","Test3"], "Nefunguje první funkce se vstupem na tři řádky")
        os.remove("test02.txt")

    # Test function addSomeTextToFile
    def test2AFunctionAddSomeTextToFile(self):
        with open("test03.txt", mode='w', encoding='utf-8') as a_file:
            # Zápis do souboru
            a_file.write("Test4\n")
        f.addSomeTextToFile("test03.txt", "Test5")
        radky = []
        # Připojení k souboru - mód čtení ze souboru
        with open("test03.txt", mode="r", encoding="utf-8") as a_file:
            # Čtení ze souboru - po řádcích
            for radek in a_file:
                radek = radek.replace("\n", "")
                radky.append(radek)
        self.assertTrue(radky == ["Test4", "Test5"], "Nefunguje základní druhá funkce")
        os.remove("test03.txt")

    def test2BFunctionAddSomeTextToFile(self):
        with open("test04.txt", mode='w', encoding='utf-8') as a_file:
            # Zápis do souboru
            a_file.write("Test14\n")
        f.addSomeTextToFile("test04.txt", "Test15")
        f.addSomeTextToFile("test04.txt", "Test16")
        f.addSomeTextToFile("test04.txt", "Test17")
        radky = []
        # Připojení k souboru - mód čtení ze souboru
        with open("test04.txt", mode="r", encoding="utf-8") as a_file:
            # Čtení ze souboru - po řádcích
            for radek in a_file:
                radek = radek.replace("\n", "")
                radky.append(radek)
        self.assertTrue(radky == ["Test14", "Test15","Test16","Test17"], "Nefunguje druhá funkce vícekrát použitá. Každé nové použití se musí načítat na nový řádek.")
        os.remove("test04.txt")


# Test function makeFileAndWriteText
    def test3AFunctionDeleteTextFromFile(self):
        # Připojení k souboru - mód čtení ze souboru
        with open("test05.txt", mode="w", encoding="utf-8") as a_file:
            # Čtení ze souboru - po řádcích
            a_file.write("Text")
        f.deleteTextFromFile("test05.txt")
        radek1 = ""
        with open("test05.txt", mode="r", encoding="utf-8") as a_file:
            # Čtení ze souboru - po řádcích
            for radek in a_file:
                radek1 = radek
        self.assertTrue((radek1 == ""),"Nefunguje 3. funkce, která má smazat všechen text. V textu zůstalo '" + radek1 +"'.")
        os.remove("test05.txt")

    def testCompleteTest(self):
        f.makeFileAndWriteText("test06.txt", "Test100\n")
        f.addSomeTextToFile("test06.txt", "Test101")
        f.deleteTextFromFile("test06.txt")
        f.addSomeTextToFile("test06.txt", "Test102")
        f.addSomeTextToFile("test06.txt", "Test103")
        radky = []
        # Připojení k souboru - mód čtení ze souboru
        with open("test06.txt", mode="r", encoding="utf-8") as a_file:
            # Čtení ze souboru - po řádcích
            for radek in a_file:
                radek = radek.replace("\n", "")
                radky.append(radek)
        self.assertTrue(radky == ["Test102", "Test103"], "Nefungují všechny 3 najednou použité funkce.")
        os.remove("test06.txt")



if __name__ == '__main__':
    unittest.main()